variables:
  BUMP_VERSION_IMAGE: msk-hdp-dn171.megafon.ru:5000/megafon/bump2version:0.0.1
  GIT_URL: https://${GITLAB_ACCESS_TOKEN_NAME}:${GITLAB_ACCESS_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_PATH}.git
stages:
  - create_tag
  - build_images
  - update_dev_version
create_tag_step:
  stage: create_tag
  image: $BUMP_VERSION_IMAGE
  tags:
    - docker
  before_script:
    - ls -lah /opt/certs/*.crt
    - cp /opt/certs/*.crt /usr/local/share/ca-certificates/
    - update-ca-certificates
  script:
    - git remote set-url origin $GIT_URL
    - git config --global user.email "gitlab-runner@megafon.ru" && git config --global user.name "Gitlab CI"
    - git checkout master
    - git pull "$GIT_URL" master
    - release_version=$(cat version)
    - echo $release_version
    - git tag v$release_version
    - git push "$GIT_URL" --tags
  only:
    - master

build_images:
  stage: build_images
  image: docker:dind
  tags:
    - docker
  script:
    - VERSION=$(cat version)
    - cd images/spark_mlflow
    - docker build -t docker-itbigdata.megafon.ru/mlops/mlflow_project_runner:$VERSION .
    - docker tag docker-itbigdata.megafon.ru/mlops/mlflow_project_runner:$VERSION docker-itbigdata.megafon.ru/mlops/mlflow_project_runner:latest
    - docker push docker-itbigdata.megafon.ru/mlops/mlflow_project_runner:$VERSION
    - docker push docker-itbigdata.megafon.ru/mlops/mlflow_project_runner:latest
    - cd ../sqoop_mlflow
    - docker build -t docker-itbigdata.megafon.ru/mlops/mlflow_sqoop:$VERSION .
    - docker tag docker-itbigdata.megafon.ru/mlops/mlflow_sqoop:$VERSION docker-itbigdata.megafon.ru/mlops/mlflow_sqoop:latest
    - docker push docker-itbigdata.megafon.ru/mlops/mlflow_sqoop:$VERSION

    - docker push docker-itbigdata.megafon.ru/mlops/mlflow_sqoop:latest
  only:
    - master

 

update_dev_version:
  stage: update_dev_version
  image: $BUMP_VERSION_IMAGE
  tags:
    - docker
  before_script:
    - ls -lah /opt/certs/*.crt
    - cp /opt/certs/*.crt /usr/local/share/ca-certificates/
    - update-ca-certificates
  script:
    - git remote set-url origin $GIT_URL
    - git config --global user.email "gitlab-runner@megafon.ru" && git config --global user.name "Gitlab CI"
    - git fetch --all
    - git checkout --track origin/develop
    - git pull "$GIT_URL" develop
    - bump2version --commit --verbose patch
    - git push "$GIT_URL" develop
  only:
    - master
